/**********************************************************************
Copyright (c) 2012 Alexander Kerner. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 ***********************************************************************/

package net.sf.bioutils.proteomics;

import java.util.List;

import net.sf.kerner.utils.Transformer;

/**
 * {@link Transformer} to parse a {@link Peak} from a {@link List} of Strings.
 * <p>
 * <b>Example:</b><br>
 * </p>
 * <p>
 * 
 * <pre>
 * TODO example
 * </pre>
 * 
 * </p>
 * 
 * @author <a href="mailto:alex.kerner.24@googlemail.com">Alexander Kerner</a>
 * @version 2012-07-30
 * @see Transformer
 * @see Peak
 * @param <P>
 *            type of {@link Peak}
 */
public interface StringListToPeakTransformer<P extends Peak> extends
		Transformer<List<? extends String>, P> {

	/**
	 * @return newly parsed {@code Peak} or null, if parsing failed
	 */
	public P transform(List<? extends String> element);

}
